/*******************************************************************************
    Copyright (c) 2015-2016 NVIDIA Corporation

    Permission is hereby granted, free of charge, to any person obtaining a copy
    of this software and associated documentation files (the "Software"), to
    deal in the Software without restriction, including without limitation the
    rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
    sell copies of the Software, and to permit persons to whom the Software is
    furnished to do so, subject to the following conditions:

        The above copyright notice and this permission notice shall be
        included in all copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
    THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
    FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
    DEALINGS IN THE SOFTWARE.

*******************************************************************************/

#include "uvm_perf.h"

#ifndef _UVM_FULL_PERF_H_
#define _UVM_FULL_PERF_H_

NV_STATUS uvmfull_perf_get_thrashing_info(UVM_PERF_GET_THRASHING_INFO_PARAMS *params, struct file *filp);


void uvmfull_notify_fault(Uvm2MbVaDesc *desc2M, NvU64 pteFault, NvU64 pteBase, NvU32 cpuPages, UvmGpuId gpuId,
                          UvmFaultType faultType, UvmAccessType accessType, NvU64 tstamp);

void uvmfull_notify_retry(Uvm2MbVaDesc *desc2M, NvU64 pteFault, NvU64 pteBase, NvU32 cpuPages, UvmGpuId gpuId,
                          UvmFaultType faultType, UvmAccessType accessType, NvU64 tstamp);

#endif

