/*******************************************************************************
    Copyright (c) 2014-2015 NVIDIA Corporation

    Permission is hereby granted, free of charge, to any person obtaining a copy
    of this software and associated documentation files (the "Software"), to
    deal in the Software without restriction, including without limitation the
    rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
    sell copies of the Software, and to permit persons to whom the Software is
    furnished to do so, subject to the following conditions:

        The above copyright notice and this permission notice shall be
        included in all copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
    THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
    FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
    DEALINGS IN THE SOFTWARE.

*******************************************************************************/

#include "uvm_full.h"

void inline uvmfull_set_pte_swtransient (UvmGpuPte* pGpuPte, NvBool swtransient )
{
    pGpuPte->swtransient = swtransient;
}
void inline uvmfull_set_pte_swcachevalid (UvmGpuPte* pGpuPte, NvBool swcachevalid )
{
    pGpuPte->swcachevalid = swcachevalid;
}
void inline uvmfull_set_pte_valid (UvmGpuPte* pGpuPte, NvBool valid )
{
    pGpuPte->valid = valid;
}
void inline uvmfull_set_pte_zfod_mapped (UvmGpuPte* pGpuPte, NvBool zfodMapped)
{
    pGpuPte->zfodMapped = zfodMapped;
}
void inline uvmfull_set_pte_readonly (UvmGpuPte* pGpuPte, NvBool readonly )
{
    pGpuPte->readonly = readonly;
}
void inline uvmfull_set_pte_atomic (UvmGpuPte* pGpuPte, NvBool atomic )
{
    pGpuPte->atomic = atomic;
}
void inline uvmfull_set_pte_aperture (UvmGpuPte* pGpuPte, UvmMemType aperture )
{
    pGpuPte->aperture = aperture;
}
void inline uvmfull_set_pte_peerid (UvmGpuPte* pGpuPte, NvU32 peerid )
{
    pGpuPte->peerid = peerid;
}
void inline uvmfull_set_pte_vol (UvmGpuPte* pGpuPte, NvBool vol )
{
    pGpuPte->vol = vol;
}
void inline uvmfull_set_pte_hints (UvmGpuPte* pGpuPte, NvU32 hints )
{
    pGpuPte->hints = hints;
}
void inline uvmfull_set_pte_pfnvalid (UvmGpuPte* pGpuPte, NvBool pfnvalid )
{
    pGpuPte->pfnvalid = pfnvalid;
}
void inline uvmfull_set_pte_pfn (UvmGpuPte* pGpuPte, NvU64 pfn )
{
    pGpuPte->pfn = pfn;
}
inline NvBool uvmfull_get_pte_swcachevalid (UvmGpuPte* pGpuPte, NvBool swcachevalid )
{
    return (NvBool) pGpuPte->swcachevalid;
}
inline NvBool uvmfull_get_pte_valid (UvmGpuPte* pGpuPte, NvBool valid )
{
    return (NvBool) pGpuPte->valid;
}
inline NvBool uvmfull_get_pte_readonly (UvmGpuPte* pGpuPte, NvBool readonly )
{
    return (NvBool) pGpuPte->readonly;
}
inline NvBool uvmfull_get_pte_atomic (UvmGpuPte* pGpuPte, NvBool atomic )
{
    return (NvBool) pGpuPte->atomic;
}
inline UvmMemType uvmfull_get_pte_aperture (UvmGpuPte* pGpuPte, UvmMemType aperture )
{
    return (UvmMemType) pGpuPte->aperture;
}
inline NvU32 uvmfull_get_pte_peerid (UvmGpuPte* pGpuPte, NvU32 peerid )
{
    return (NvU32) pGpuPte->peerid;
}
inline NvBool uvmfull_get_pte_vol (UvmGpuPte* pGpuPte, NvBool vol )
{
    return (NvBool) pGpuPte->vol;
}
inline NvU32 uvmfull_get_pte_hints (UvmGpuPte* pGpuPte, NvU32 hints )
{
    return (NvU32) pGpuPte->hints;
}
inline NvBool uvmfull_get_pte_pfnvalid (UvmGpuPte* pGpuPte, NvBool pfnvalid )
{
    return (NvBool) pGpuPte->pfnvalid;
}
inline NvU64 uvmfull_get_pte_pfn (UvmGpuPte* pGpuPte, NvU64 pfn )
{
    return (NvU64) pGpuPte->pfn;
}
inline NvBool uvmfull_get_pte_swtransient (UvmGpuPte* pGpuPte )
{
    return (NvBool)pGpuPte->swtransient;
}
