/*******************************************************************************
    Copyright (c) 2014-2015 NVIDIA Corporation

    Permission is hereby granted, free of charge, to any person obtaining a copy
    of this software and associated documentation files (the "Software"), to
    deal in the Software without restriction, including without limitation the
    rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
    sell copies of the Software, and to permit persons to whom the Software is
    furnished to do so, subject to the following conditions:

        The above copyright notice and this permission notice shall be
        included in all copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
    THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
    FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
    DEALINGS IN THE SOFTWARE.

*******************************************************************************/

#ifndef _UVM_FULL_TYPES_H_
#define _UVM_FULL_TYPES_H_

typedef enum
{
    UvmMemType_vidmem=0,
    UvmMemType_sysmem_ncoh=1,
    UvmMemType_sysmem_coh=2,
    UvmMemType_peer=3,
    UvmMemType_invalid=4,
} UvmMemType;

typedef NvU32 UvmGpuId;
typedef NvU32 UvmGpuPeerId;
typedef NvU64 UvmGpuPfn;

// Forward declarations:
typedef struct UvmUuidMapEntry_tag            UvmUuidMapEntry;
typedef struct UvmUuidMap_tag                 UvmUuidMap;
typedef struct UvmGlobalState_tag             UvmGlobalState;
typedef struct UvmGpu_tag                     UvmGpu;
typedef struct UvmGpuPeerCaps_tag             UvmGpuPeerCaps;
typedef struct UvmGpuVaspace_tag              UvmGpuVaspace;
typedef struct UvmVaspace_tag                 UvmVaspace;
typedef struct Uvm2MbVaDesc_tag               Uvm2MbVaDesc;
typedef struct UvmGpuPde_tag                  UvmGpuPde;
typedef struct UvmGpuPageTable_tag            UvmGpuPageTable;
typedef struct UvmGpuPte_tag                  UvmGpuPte;
typedef struct UvmPteHints_tag                UvmPteHints;
typedef struct UvmClientChannel_tag           UvmClientChannel;
typedef struct UvmGpuPteUpdateParams_tag      UvmGpuPteUpdateParams;
typedef struct UvmGpuFaultBufferInfo_tag      UvmGpuFaultBufferInfo;
typedef struct UvmPteHintsParams_tag          UvmPteHintsParams;
typedef struct UvmGpuCancelFaultInfo_tag      UvmGpuCancelFaultInfo;
typedef struct UvmGpuPageTablePhyAddrDesc_tag UvmGpuPageTablePhyAddrDesc;
typedef struct UvmHashMap_tag                 UvmHashMap;
typedef struct UvmHashEntry_tag               UvmHashEntry;
typedef struct UvmGpuPb_tag                   UvmGpuPb;
typedef struct UvmPbOps_tag                   UvmPbOps;
typedef struct UvmPendingFault_tag            UvmPendingFault;
typedef struct UvmRmMemory_tag                UvmRmMemory;
typedef struct UvmRmMemoryRegion_tag          UvmRmMemoryRegion;
typedef struct UvmEngCtx_tag                  UvmEngCtx;

typedef enum
{
    UvmVatAccess_GenericQuery   = 0, // Returns leaf if present
    UvmVatAccess_GenericTouch   = 1, // Allocs logical levels and returns leaf
    UvmVatAccess_GPUQuery       = 2, // Returns leaf if present
    UvmVatAccess_GPUTouch       = 3, // Allocs GPU levels in HW and returns leaf
    UvmVatAccess_GenericReclaim = 4, // Reclaims GPU PDEs and levels if allocated
    UvmVatAccess_Invalid        = 5,
} UvmVatAccess;

typedef struct UvmVaTrieLevel0Entry_t       UvmVatL0Entry;
typedef struct UvmVaTrieLevel0_t            UvmVatL0;
typedef struct UvmVaTrieLevel1Entry_t       UvmVatL1Entry;
typedef struct UvmVaTrieLevel1_t            UvmVatL1;
typedef struct UvmVaTrieLevel2Entry_t       UvmVatL2Entry;
typedef struct UvmVaTrieLevel2_t            UvmVatL2;
typedef struct UvmVaTrieLevel3Entry_t       UvmVatL3Entry;
typedef struct UvmVaTrieLevel3_t            UvmVatL3;
typedef struct UvmVaTrie_t                  UvmVat;
typedef struct UvmVaTrieLevelHeader_t       UvmVatLevelHeader;
typedef struct UvmVaTrieLevelGpuHeader_t    UvmVatLevelGpuHeader;
typedef struct UvmVaTrieContext_t           UvmVatContext;
typedef struct UvmVatLockState_t            UvmVatLockState;

typedef struct UvmPaPool_tag                UvmPaPool;
typedef struct UvmPaManager_tag             UvmPaManager;
typedef struct UvmPaDesc_tag                UvmPaDesc;
typedef struct UvmPaToVa_tag                UvmPaToVa;
typedef struct UvmPaAllocationOptions_tag   UvmPaAllocationOptions;



#endif  // _UVM_FULL_TYPES_H_
